diff --git a/expected/pg_bigm.out b/expected/pg_bigm.out
index 4dc0d99..09bf091 100644
--- a/expected/pg_bigm.out
+++ b/expected/pg_bigm.out
@@ -36,3 +36,190 @@ SELECT likequery ('pg_bigmは検索性能を200%向上させました。');
  %pg\_bigmは検索性能を200\%向上させました。%
 (1 row)
 
+/* tests for full-text search */
+CREATE TABLE tbl (doc text, tag text);
+INSERT INTO tbl VALUES ('pg_trgm - Tool that provides 3-gram full text search capability in PostgreSQL', 'pg_trgm');
+INSERT INTO tbl VALUES ('pg_bigm - Tool that provides 2-gram full text search capability in PostgreSQL', 'pg_bigm');
+INSERT INTO tbl VALUES ('pg_bigm has improved the full text search performance by 200%.','pg_bigm performance');
+INSERT INTO tbl VALUES ('You can create an index for full text search by using GIN index.', 'full text search');
+INSERT INTO tbl VALUES ('pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール', 'pg_trgm');
+INSERT INTO tbl VALUES ('pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール', 'pg_bigm');
+INSERT INTO tbl VALUES ('pg_bigmは検索性能を200%向上させました。', 'pg_bigm 検索性能');
+INSERT INTO tbl VALUES ('GINインデックスを利用して全文検索用のインデックスを作成します。', '全文検索');
+CREATE INDEX tbl_idx ON tbl USING gin (doc gin_bigm_ops);
+SET enable_seqscan=off;
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE likequery ('bigm');
+                 QUERY PLAN                  
+---------------------------------------------
+ Bitmap Heap Scan on tbl
+   Recheck Cond: (doc ~~ '%bigm%'::text)
+   ->  Bitmap Index Scan on tbl_idx
+         Index Cond: (doc ~~ '%bigm%'::text)
+(4 rows)
+
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE likequery ('検索');
+                 QUERY PLAN                  
+---------------------------------------------
+ Bitmap Heap Scan on tbl
+   Recheck Cond: (doc ~~ '%検索%'::text)
+   ->  Bitmap Index Scan on tbl_idx
+         Index Cond: (doc ~~ '%検索%'::text)
+(4 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery (NULL);
+ doc 
+-----
+(0 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('');
+ doc 
+-----
+(0 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('%');
+                              doc                               
+----------------------------------------------------------------
+ pg_bigm has improved the full text search performance by 200%.
+ pg_bigmは検索性能を200%向上させました。
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('by');
+                               doc                                
+------------------------------------------------------------------
+ pg_bigm has improved the full text search performance by 200%.
+ You can create an index for full text search by using GIN index.
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('GIN');
+                               doc                                
+------------------------------------------------------------------
+ You can create an index for full text search by using GIN index.
+ GINインデックスを利用して全文検索用のインデックスを作成します。
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('tool');
+ doc 
+-----
+(0 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('Tool');
+                                      doc                                      
+-------------------------------------------------------------------------------
+ pg_trgm - Tool that provides 3-gram full text search capability in PostgreSQL
+ pg_bigm - Tool that provides 2-gram full text search capability in PostgreSQL
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('performance');
+                              doc                               
+----------------------------------------------------------------
+ pg_bigm has improved the full text search performance by 200%.
+(1 row)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('使');
+                              doc                               
+----------------------------------------------------------------
+ pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール
+ pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('検索');
+                               doc                               
+-----------------------------------------------------------------
+ pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール
+ pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール
+ pg_bigmは検索性能を200%向上させました。
+ GINインデックスを利用して全文検索用のインデックスを作成します。
+(4 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('ツール');
+                              doc                               
+----------------------------------------------------------------
+ pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール
+ pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('インデックスを作成');
+                               doc                               
+-----------------------------------------------------------------
+ GINインデックスを利用して全文検索用のインデックスを作成します。
+(1 row)
+
+SELECT doc FROM tbl WHERE doc LIKE likequery ('3-gramの全文検索');
+                              doc                               
+----------------------------------------------------------------
+ pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール
+(1 row)
+
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE '%bigm%';
+                 QUERY PLAN                  
+---------------------------------------------
+ Bitmap Heap Scan on tbl
+   Recheck Cond: (doc ~~ '%bigm%'::text)
+   ->  Bitmap Index Scan on tbl_idx
+         Index Cond: (doc ~~ '%bigm%'::text)
+(4 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE '%Tool%';
+                                      doc                                      
+-------------------------------------------------------------------------------
+ pg_trgm - Tool that provides 3-gram full text search capability in PostgreSQL
+ pg_bigm - Tool that provides 2-gram full text search capability in PostgreSQL
+(2 rows)
+
+SELECT doc FROM tbl WHERE doc LIKE '%検索%';
+                               doc                               
+-----------------------------------------------------------------
+ pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール
+ pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール
+ pg_bigmは検索性能を200%向上させました。
+ GINインデックスを利用して全文検索用のインデックスを作成します。
+(4 rows)
+
+DROP INDEX tbl_idx;
+CREATE INDEX tbl_multi_idx ON tbl USING gin (doc gin_bigm_ops, tag gin_bigm_ops);
+EXPLAIN (COSTS off) SELECT * FROM tbl WHERE tag LIKE likequery('bigm') AND doc LIKE likequery('search');
+                                 QUERY PLAN                                  
+-----------------------------------------------------------------------------
+ Bitmap Heap Scan on tbl
+   Recheck Cond: ((doc ~~ '%search%'::text) AND (tag ~~ '%bigm%'::text))
+   ->  Bitmap Index Scan on tbl_multi_idx
+         Index Cond: ((doc ~~ '%search%'::text) AND (tag ~~ '%bigm%'::text))
+(4 rows)
+
+SELECT * FROM tbl WHERE doc LIKE likequery('search') AND tag LIKE likequery('bigm');
+                                      doc                                      |         tag         
+-------------------------------------------------------------------------------+---------------------
+ pg_bigm - Tool that provides 2-gram full text search capability in PostgreSQL | pg_bigm
+ pg_bigm has improved the full text search performance by 200%.                | pg_bigm performance
+(2 rows)
+
+SELECT * FROM tbl WHERE doc LIKE likequery('ツール') AND tag LIKE likequery('bigm');
+                              doc                               |   tag   
+----------------------------------------------------------------+---------
+ pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール | pg_bigm
+(1 row)
+
+SELECT * FROM tbl WHERE doc LIKE likequery('向上させ') AND tag LIKE likequery('性能');
+                   doc                   |       tag        
+-----------------------------------------+------------------
+ pg_bigmは検索性能を200%向上させました。 | pg_bigm 検索性能
+(1 row)
+
+SELECT * FROM tbl WHERE doc LIKE likequery('200%') AND tag LIKE likequery('性能');
+                   doc                   |       tag        
+-----------------------------------------+------------------
+ pg_bigmは検索性能を200%向上させました。 | pg_bigm 検索性能
+(1 row)
+
+SELECT * FROM tbl WHERE doc LIKE likequery('GIN') AND tag LIKE likequery('bigm');
+ doc | tag 
+-----+-----
+(0 rows)
+
+DROP TABLE tbl;
+DROP EXTENSION pg_bigm;
+SELECT likequery('test');
+ERROR:  function likequery(unknown) does not exist
+LINE 1: SELECT likequery('test');
+               ^
+HINT:  No function matches the given name and argument types. You might need to add explicit type casts.
diff --git a/sql/pg_bigm.sql b/sql/pg_bigm.sql
index 1f1f1e8..5c3f873 100644
--- a/sql/pg_bigm.sql
+++ b/sql/pg_bigm.sql
@@ -7,3 +7,50 @@ SELECT likequery ('aBc023#*^&');
 SELECT likequery ('ポスグレの全文検索');
 SELECT likequery ('\_%');
 SELECT likequery ('pg_bigmは検索性能を200%向上させました。');
+
+/* tests for full-text search */
+CREATE TABLE tbl (doc text, tag text);
+INSERT INTO tbl VALUES ('pg_trgm - Tool that provides 3-gram full text search capability in PostgreSQL', 'pg_trgm');
+INSERT INTO tbl VALUES ('pg_bigm - Tool that provides 2-gram full text search capability in PostgreSQL', 'pg_bigm');
+INSERT INTO tbl VALUES ('pg_bigm has improved the full text search performance by 200%.','pg_bigm performance');
+INSERT INTO tbl VALUES ('You can create an index for full text search by using GIN index.', 'full text search');
+INSERT INTO tbl VALUES ('pg_trgm - PostgreSQLで3-gramの全文検索を使えるようにするツール', 'pg_trgm');
+INSERT INTO tbl VALUES ('pg_bigm - PostgreSQLで2-gramの全文検索を使えるようにするツール', 'pg_bigm');
+INSERT INTO tbl VALUES ('pg_bigmは検索性能を200%向上させました。', 'pg_bigm 検索性能');
+INSERT INTO tbl VALUES ('GINインデックスを利用して全文検索用のインデックスを作成します。', '全文検索');
+CREATE INDEX tbl_idx ON tbl USING gin (doc gin_bigm_ops);
+SET enable_seqscan=off;
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE likequery ('bigm');
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE likequery ('検索');
+
+SELECT doc FROM tbl WHERE doc LIKE likequery (NULL);
+SELECT doc FROM tbl WHERE doc LIKE likequery ('');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('%');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('by');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('GIN');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('tool');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('Tool');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('performance');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('使');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('検索');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('ツール');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('インデックスを作成');
+SELECT doc FROM tbl WHERE doc LIKE likequery ('3-gramの全文検索');
+
+EXPLAIN (COSTS off) SELECT doc FROM tbl WHERE doc LIKE '%bigm%';
+SELECT doc FROM tbl WHERE doc LIKE '%Tool%';
+SELECT doc FROM tbl WHERE doc LIKE '%検索%';
+
+DROP INDEX tbl_idx;
+CREATE INDEX tbl_multi_idx ON tbl USING gin (doc gin_bigm_ops, tag gin_bigm_ops);
+EXPLAIN (COSTS off) SELECT * FROM tbl WHERE tag LIKE likequery('bigm') AND doc LIKE likequery('search');
+SELECT * FROM tbl WHERE doc LIKE likequery('search') AND tag LIKE likequery('bigm');
+SELECT * FROM tbl WHERE doc LIKE likequery('ツール') AND tag LIKE likequery('bigm');
+SELECT * FROM tbl WHERE doc LIKE likequery('向上させ') AND tag LIKE likequery('性能');
+SELECT * FROM tbl WHERE doc LIKE likequery('200%') AND tag LIKE likequery('性能');
+SELECT * FROM tbl WHERE doc LIKE likequery('GIN') AND tag LIKE likequery('bigm');
+
+DROP TABLE tbl;
+
+DROP EXTENSION pg_bigm;
+SELECT likequery('test');
